package struct.alg;

import java.io.IOException;

import struct.types.Evaluator;
import struct.types.Instance;

public class BatchLearner implements StructuredLearner {

	public void trainAndEvaluate(Instance[] training, Instance[] testing,
			BatchUpdator update, Predictor predictor,
			String trainingFeatureFile, String testingFeatureFile,
			Evaluator eval) throws IOException {

		long start = System.currentTimeMillis();

		update.update(training, predictor, trainingFeatureFile);

		long end = System.currentTimeMillis();
		System.out.println("==========================");
		System.out.println("Final Performance.");
		System.out.println("==========================");
		System.out.println("Training took: " + (end - start));
		System.out.println("Training");
		eval.evaluate(training, predictor, trainingFeatureFile);
		System.out.println("Testing");
		eval.evaluate(testing, predictor, testingFeatureFile);
	}

}
