package struct.sequence;

import struct.sequence.SequencePredictor.PredictCommitteeType;
import struct.types.Features;
import struct.types.Instance;

public class ConfidenceEstimatorKDraws extends ConfidenceEstimator {
	int k;
	double multiplier;
	PredictCommitteeType drawsCommitteeType;

	public ConfidenceEstimatorKDraws(double multiplier, int k,
			PredictCommitteeType drawsCommitteeType) {
		this.k = k;
		this.multiplier = multiplier;
		this.drawsCommitteeType = drawsCommitteeType;
	}

	public void estimateInst(Instance inst, Features feats,
			LabelConfScore[] allWordsScores, SequencePredictor predictor) {

		// Use K-Draws
		predictor.setCommitteeType(drawsCommitteeType);
		predictor.setDrawsMultiplier(multiplier);

		SequencePrediction kPredictions = predictor.decode(inst, feats, k);

		for (int wordIdx = 0; wordIdx < allWordsScores.length; wordIdx++) {
			double score = ConfEstimation.evalWordConfByCommittee(kPredictions,
					k, wordIdx);
			allWordsScores[wordIdx].score = score;
		}

	}

}
