package struct.sequence;

import java.text.DecimalFormat;

public class SequenceEvaluationAveragedResult extends SequenceEvaluationResult {
	public double precisionStddev;
	public double recallStddev;
	public double fMeasureStddev;

	public void setStddevValues(double precisionStddev, double recallStddev,
			double fMeasureStddev) {
		this.precisionStddev = precisionStddev;
		this.recallStddev = recallStddev;
		this.fMeasureStddev = fMeasureStddev;
	}

	public static void printResultsArray(
			SequenceEvaluationAveragedResult[] evalResults) {
		int len = evalResults.length;
		DecimalFormat nf = new DecimalFormat();
		nf.setMaximumFractionDigits(5);
		System.out.println();
		System.out.println("Prec\tStddev\tRecall\tStddev\tF-Meas\tStddev");
		for (int idx = 0; idx < len; idx++) {
			System.out.print(nf.format(evalResults[idx].precision) + "\t");
			System.out
					.print(nf.format(evalResults[idx].precisionStddev) + "\t");
			System.out.print(nf.format(evalResults[idx].recall) + "\t");
			System.out.print(nf.format(evalResults[idx].recallStddev) + "\t");
			System.out.print(nf.format(evalResults[idx].fMeasure) + "\t");
			System.out.print(nf.format(evalResults[idx].fMeasureStddev));
			System.out.println();
		}
	}
}
