package struct.sequence;

import java.text.DecimalFormat;


public class SequenceEvaluationResult {
	public double precision;
	public double recall;
	public double fMeasure;

	public void setValues(double precision, double recall, double fMeasure) {
		this.precision = precision;
		this.recall = recall;
		this.fMeasure = fMeasure;
	}

	public interface getValueFromEvaluationResult {
		public double getVal(SequenceEvaluationResult res);
	}

	public static class getPrecision implements getValueFromEvaluationResult {
		public double getVal(SequenceEvaluationResult res) {
			return res.precision;
		}
	}

	public static class getRecall implements getValueFromEvaluationResult {
		public double getVal(SequenceEvaluationResult res) {
			return res.recall;
		}
	}

	public static class getFMeasure implements getValueFromEvaluationResult {
		public double getVal(SequenceEvaluationResult res) {
			return res.fMeasure;
		}
	}
	
	public static void printResultsArray(SequenceEvaluationResult[] evalResults){
		int len = evalResults.length;
		DecimalFormat nf = new DecimalFormat();
		nf.setMaximumFractionDigits(5);
		System.out.println();
		System.out.println("Prec\tRecall\tF-Meas");
		for (int idx = 0; idx < len; idx++) {
			System.out.print(nf.format(evalResults[idx].precision) + "\t");
			System.out.print(nf.format(evalResults[idx].recall) + "\t");
			System.out.print(nf.format(evalResults[idx].fMeasure) + "\t");
			System.out.println();
		}		
	}
}
