package struct.sequence;

import struct.types.Prediction;

public class SequencePrediction implements Prediction {

	public SequenceLabel[] labels;

	public SequencePrediction(SequenceLabel[] labels) {
		this.labels = labels;
	}
	
	public SequencePrediction(SequenceLabel label) {
		this.labels = new SequenceLabel[1];
		this.labels[0] = label;
	}

	public SequenceLabel getBestLabel() {
		return labels[0];
	}

	public SequenceLabel getLabelByRank(int rank) {
		if (rank >= labels.length)
			return null;
		return labels[rank];
	}

	public SequenceLabel[] getAllLabels() {
		return labels;
	}

	public int getNumLabels() {
		return labels.length;
	}

}
