import struct.types.*;
import struct.sequence.*;
import struct.alg.*;

import java.io.*;

public class handw
{
    public static void main (String[] args) throws IOException
    {

	HandWritDataManager manager = new HandWritDataManager(2);

	manager.createAlphabets();
	manager.closeAlphabets();

	int numFeats = manager.dataAlphabet.size();
	System.out.println("Feature Dimension: " + numFeats);
		
	SequenceInstance[] trainingData = manager.readData(args[0],false);

	SequenceInstance[] develData = manager.readData(args[1],false);
		
	System.out.println("Training size: " + trainingData.length);
	System.out.println("Testing size: " + develData.length);
	
	int numIters = 50;

	OnlineLearner learner = new OnlineLearner();
	Predictor predictor = new SequencePredictor(numFeats);
	//OnlineUpdator updator = new PerceptronUpdator();
	//OnlineUpdator updator = new KBestMiraUpdator(20);
	OnlineUpdator updator = new QPUpdators(args[2], manager.tagAlphabet);
	learner.trainAndEvaluate(trainingData, develData,
				 updator, predictor, numIters,
				 args[0]+".feats",args[1]+".feats",
				 new SequenceAccuracyEvaluator());

	//	File f = new File(args[0]+".feats"); f.delete();
	//f = new File(args[1]+".feats"); f.delete();
    }

}
