import struct.types.*;
import struct.sequence.*;
import struct.alg.*;

import java.io.*;

public class tagger
{
    public static void main (String[] args) throws Exception
    {

	if(args[0].equals("train")) {

	    SequenceDataManager manager = new NeDataManager();
	    
	    manager.createAlphabets(args[1],false);
	    manager.closeAlphabets();
	    
	    int numFeats = manager.dataAlphabet.size();
	    System.out.println("Feature Dimension: " + numFeats);
	    
	    SequenceInstance[] trainingData = manager.readData(args[1],true);
	    
	    SequenceInstance[] develData = manager.readData(args[2],true);
	    
	    int numIters = 10;
	    
	    OnlineLearner learner = new OnlineLearner();
	    SequencePredictor predictor = new SequencePredictor(numFeats);
	    OnlineUpdator updator = new PerceptronUpdator();
	    learner.trainAndEvaluate(trainingData, develData,
				     updator, predictor, numIters,
				     args[1]+".feats",args[2]+".feats",
				     new SequenceEvaluator(manager.getTagAlphabet()));
	    
	    predictor.saveModel(args[3]);
	}

	else {

	    SequencePredictor predictor = new SequencePredictor(0);
	    predictor.loadModel(args[2]);

	    SequenceDataManager manager = new NeDataManager();

	    manager.dataAlphabet = SequenceInstance.getDataAlphabet();
	    manager.tagAlphabet = SequenceInstance.getTagAlphabet();	    
	    manager.closeAlphabets();
	    
	    int numFeats = manager.dataAlphabet.size();
	    System.out.println("Feature Dimension: " + numFeats);
	    
	    SequenceInstance[] develData = manager.readData(args[1],false);

	    SequenceEvaluator eval = new SequenceEvaluator(manager.getTagAlphabet());	    
	    
	    eval.evaluate(develData,predictor,args[1]+".feats");

	}

    }

}
