package struct.alg;

import struct.types.*;

import java.io.*;

public class BatchLearner implements StructuredLearner {


    public void trainAndEvaluate(Instance[] training,
				 Instance[] testing,
				 BatchUpdator update,
				 Predictor predictor,
				 String trainingFeatureFile,
				 String testingFeatureFile,
				 Evaluator eval) throws IOException {

	
	long start = System.currentTimeMillis();

	ObjectInputStream in = new ObjectInputStream(new FileInputStream(trainingFeatureFile));
	update.update(training, predictor, trainingFeatureFile);
	in.close();
	long end = System.currentTimeMillis();
	System.out.println("==========================");
	System.out.println("Final Performance.");
	System.out.println("==========================");
    }

}
