package struct.discontinuous;

import struct.types.*;

public class DiscontinuousFeatures implements Features {

    private FeatureVector[][] fvs_ij;
    private FeatureVector[] fvs_j;

    public DiscontinuousFeatures(FeatureVector[][] fvs_ij,
				 FeatureVector[] fvs_j) {
	this.fvs_ij = fvs_ij;
	this.fvs_j = fvs_j;
    }

    public FeatureVector getFeatureVector(int n1, int n2) {
	if(n1 >= n2) { return null; }
	return fvs_ij[n1][n2];
    }

    public FeatureVector getFeatureVector(int n) {
	return fvs_j[n];
    }
}
