package struct.discontinuous;

import struct.types.*;
import java.util.HashMap;

public class DiscontinuousLabel implements Label {
    public String[][] labels;
    public FeatureVector[] fv;
    public HashMap labMap;

    public DiscontinuousLabel(String[][] labels, FeatureVector[] fv) {

	this.labels = labels;
	this.fv = fv;

    }

    public FeatureVector getFeatureVectorRepresentation() { return fv[0]; }

    public FeatureVector getFeatureVectorRepresentation(int i) { return fv[i]; }

    public HashMap getLabelMap() {
	if(labMap == null) {
	    labMap = new HashMap();
	    for(int i = 0; i < labels.length; i++) {
		String res = "";
		for(int j = 0; j < labels[i].length; j++)
		    res += labels[i][j] + " ";
		labMap.put(res.trim(),"");
	    }
	}
	return labMap;
    }

     // evaluates a prediction against this label
    public double loss(Label pred) {
	return 1.0;
    }

    public HashMap getLabelMapNoSubset() {
	HashMap result = new HashMap();
	boolean[] isBad = new boolean[labels.length];
	for(int i = 0; i < isBad.length; i++) isBad[i] = false;
	getBadSubset(isBad);
	for(int i = 0; i < labels.length; i++) {
	    if(isBad[i]) continue;
	    String res = "";
	    for(int j = 0; j < labels[i].length; j++)
		res += labels[i][j] + " ";
	    result.put(res.trim(),"");
	}
	return result;
    }
    
    public void getBadSubset(boolean[] isBad) {
	for(int i = 0; i < labels.length; i++) {
	    if(isBad[i]) continue;
	    for(int j = i+1; j < labels.length; j++) {
		if(subset(labels[i],labels[j])) isBad[j] = true;
	    }
	}
    }
    
    public boolean subset(String[] l1, String[] l2) {
	boolean overLap = true;
	// l1 subset of l2
	for(int i = 0; i < l1.length; i++) {
	    if(l1[i].equals("I") && !l2[i].equals(l1[i]))
		overLap = false;
	}
	if(overLap) return true;
	overLap = true;
	// l2 subset of l1
	for(int i = 0; i < l1.length; i++) {
	    if(l2[i].equals("I") && !l2[i].equals(l1[i]))
		overLap = false;
	}
	return overLap;
    }

}

