package struct.sequence;

import struct.types.*;
import struct.alg.*;

import gnu.trove.*;

import java.io.*;
import java.text.DecimalFormat;
 
public class SequenceAccuracyEvaluator implements Evaluator {


    public void evaluate(Instance[] data, Predictor pred) {
	System.out.println("Not implemented.");
    }

    public void evaluate(Instance[] data, Predictor predictor, String featureFile) throws IOException {
	int acc_corr = 0; int acc_tot = 0;
	
	System.out.println("Evaluating ... ");

	ObjectInputStream in = new ObjectInputStream(new FileInputStream(featureFile));

	for(int k = 0; k < data.length; k++) {

	    Instance inst = data[k];
	    Features feats = data[k].getFeatures(in);

	    SequencePrediction prediction = (SequencePrediction)predictor.decode(inst,feats);

	    String[] act_spans = ((SequenceLabel)inst.getLabel()).tags;
	    String[] pred_spans = ((SequenceLabel)prediction.getBestLabel()).tags;

	    for(int i = 1; i < pred_spans.length; i++) {
		String pred = pred_spans[i];
		String act = act_spans[i];
		if(pred.equals(act))
		    acc_corr++;
		acc_tot++;
		
	    }
	}
	
	in.close();
	DecimalFormat nf = new DecimalFormat();
	nf.setMaximumFractionDigits(5);
 
	System.out.println("Total:");
	System.out.println("\tTotal: " + acc_tot +
			   ", Correct: " + acc_corr);
	System.out.println("\tAccuracy: " + nf.format(((double)acc_corr/acc_tot)));
	
	System.out.println("done.");
    }


}
