package struct.sequence;

import struct.types.*;

public class SequenceLabel implements Label {
    public String[] tags;
    public FeatureVector fv;

    public SequenceLabel(String[] tags, FeatureVector fv) {

	this.tags = tags;
	this.fv = fv;

    }

    public FeatureVector getFeatureVectorRepresentation() { return fv; }

     // evaluates a prediction against this label
    public double loss(Label pred) {

	return (double)hammingDistance(pred);
	
    }

    public int hammingDistance(Label pred) {
	SequenceLabel spred = (SequenceLabel)pred;

	String[] act_tags = tags;
	String[] pred_tags = spred.tags;
	
	int numErrors = 0;
	
	for(int i = 0; i < act_tags.length; i++) {
	    if(!act_tags[i].equals(pred_tags[i]))
		numErrors++;
	}
	
	return numErrors;

    }

    /** 1 - hammingDistance */
    public int correct(Label pred) { return tags.length - hammingDistance(pred); }

    public String toString() {

	StringBuffer str = new StringBuffer();
	for (int i=0; i<tags.length; i++) 
	    str.append(tags[i] + " ");
	return (str.toString());

    }

}

